program Unit_demo;
{ Der Max 2000 }
uses Utasten,Ugra,Umaus;
type kugeltype=object
                yr:integer;
                h,luft,maxH,xr,x,xv,y,v,Ekin,Epot,Eges:real;
                procedure run;
                procedure init;
               end;

var mx,my,ax,ay:integer;
    l,r,da,old_l:boolean;
    x:word;
    kugel:kugeltype;

const  m=1; { kg }
       a=2000;
    luftwiederstand=0.000001;

function cosinus(a:integer):real;
begin
 cosinus:=cos(a*pi/180);
end;

function sinus(a:integer):real;
begin
 sinus:=sin(a*pi/180);
end;

function XKolision2(kx,ky,bx,by:word;k_x,k_y,b_x,b_y:integer):boolean;
begin
 if (kx+k_x>=bx ) and (kx<bx+b_x) and
    (ky+k_y-2>by) and (ky+2<=by+b_y)
       then xkolision2:=true
       else xkolision2:=false
end;

function YKolision2(kx,ky,bx,by:word;k_x,k_y,b_x,b_y:integer):boolean;
begin
 if (ky+k_y>=by ) and (ky<by+b_y) and
    (kx+k_x-2>bx) and (kx+2<=bx+b_x)
       then ykolision2:=true
       else ykolision2:=false
end;

procedure kugeltype.init;
begin
 x:=random(301)+15;
 y:=1;
 maxh:=200-y;
 h:=200-y;
 xr:=1;
 xv:=0.2;
 v:=0;
 Ekin:=(m*sqr(v)/2);
 Epot:=(m*9.81*h);
 Eges:=Ekin+Epot;
end;

procedure kugeltype.run;
begin
 if y<200-6 then y:=y+luft;
 if maxh>6 then maxh:=maxh-luft;
 if xv>0 then xv:=xv-luft/10000;
 h:=200-y;
 Eges:=m*9.81*maxh;
 Epot:=m*9.81*h;
 v:=sqrt((2*(Eges-Epot+m/2))/m/a);

 if (x>=319-5) then xr:=-1;
 if (x<=0) then xr:=1;
 if (y>=199-5) then yr:=-1;
 if (Eges-Epot<=0) then yr:=1;

 y:=y+yr*v;
 x:=x+xr*xv;
 blitsprite(round(x),round(y),1);
 luft:=luft+luftwiederstand*sqr(v);
end;

begin
 gra_on;
 load_pal('gfx2.pal');
 set_pal;                  {NUM}
 load_sprite('zeiger.scx');{ 0 }
 load_sprite('kugel.scx'); { 1 }
 mausfenstersetzen(0,0,319,199);
 kugel.init;
 tasten_on;
 repeat
  cls;
  minfo(mx,my,l,r);
  if l<>old_l then
   begin
    ax:=mx;
    ay:=my;
   end;
  old_l:=l;
  da:=l;
  if da then
   begin
    rechteck(ax,ay,mx,my,2);
    with kugel do
     begin
      if mx>ax then
       if xkolision2(ax,ay,round(x),round(y),mx-ax,my-ay,5,5) or
          xkolision2(ax,my,round(x),round(y),mx-ax,ay-my,5,5) then xr:=-xr;
      if ax>mx then
       if xkolision2(mx,my,round(x),round(y),ax-mx,ay-my,5,5) or
          xkolision2(mx,ay,round(x),round(y),ax-mx,my-ay,5,5) then xr:=-xr;

      if mx>ax then
       if ykolision2(ax,ay,round(x),round(y),mx-ax,my-ay,5,5) or
          ykolision2(ax,my,round(x),round(y),mx-ax,ay-my,5,5) then yr:=-yr;
      if ax>mx then
       if ykolision2(mx,my,round(x),round(y),ax-mx,ay-my,5,5) or
          ykolision2(mx,ay,round(x),round(y),ax-mx,my-ay,5,5) then yr:=-yr;
     end;
   end;
  kugel.run;
  for x:=0 to 319 do
   pixel(x,round(200-kugel.maxh)-1,4);
  if taste[t_space] then kugel.init;
  blitsprite(mx,my,0);
  draw_all;
 until taste[T_esc];
 gra_off;
 tasten_off;
end.
